Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfmxl.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfmxl.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfmxl.F90	(revision 14852)
@@ -26,5 +26,5 @@
    PRIVATE
 
-   PUBLIC   zdf_mxl   ! called by zdfphy.F90
+   PUBLIC   zdf_mxl, zdf_mxl_turb   ! called by zdfphy.F90
 
    INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   nmln    !: number of level in the mixed layer (used by LDF, ZDF, TRD, TOP)
@@ -41,5 +41,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id$ 
+   !! $Id$
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -65,16 +65,11 @@
       !!                  ***  ROUTINE zdfmxl  ***
       !!                   
-      !! ** Purpose :   Compute the turbocline depth and the mixed layer depth
-      !!              with density criteria.
+      !! ** Purpose :   Compute the mixed layer depth with density criteria.
       !!
       !! ** Method  :   The mixed layer depth is the shallowest W depth with 
       !!      the density of the corresponding T point (just bellow) bellow a
       !!      given value defined locally as rho(10m) + rho_c
-      !!               The turbocline depth is the depth at which the vertical
-      !!      eddy diffusivity coefficient (resulting from the vertical physics
-      !!      alone, not the isopycnal part, see trazdf.F) fall below a given
-      !!      value defined locally (avt_c here taken equal to 5 cm/s2 by default)
       !!
-      !! ** Action  :   nmln, hmld, hmlp, hmlpt
+      !! ** Action  :   nmln, hmlp, hmlpt
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -82,22 +77,25 @@
       !
       INTEGER  ::   ji, jj, jk      ! dummy loop indices
-      INTEGER  ::   iikn, iiki, ikt ! local integer
+      INTEGER  ::   iik, ikt        ! local integer
       REAL(wp) ::   zN2_c           ! local scalar
-      INTEGER, DIMENSION(jpi,jpj) ::   imld   ! 2D workspace
       !!----------------------------------------------------------------------
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
-         !                             ! allocate zdfmxl arrays
-         IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
+      IF( .NOT. l_istiled .OR. ntile == 1 )  THEN                       ! Do only on the first tile
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
+            IF(lwp) WRITE(numout,*) '~~~~~~~ '
+            !                             ! allocate zdfmxl arrays
+            IF( zdf_mxl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
+         ENDIF
       ENDIF
       !
       ! w-level of the mixing and mixed layers
-      nmln(:,:)  = nlb10                  ! Initialization to the number of w ocean point
-      hmlp(:,:)  = 0._wp                  ! here hmlp used as a dummy variable, integrating vertically N^2
+      DO_2D_OVR( nn_hls, nn_hls, nn_hls, nn_hls )
+         nmln(ji,jj)  = nlb10                  ! Initialization to the number of w ocean point
+         hmlp(ji,jj)  = 0._wp                  ! here hmlp used as a dummy variable, integrating vertically N^2
+      END_2D
       zN2_c = grav * rho_c * r1_rho0      ! convert density criteria into N^2 criteria
-      DO_3D( 1, 1, 1, 1, nlb10, jpkm1 )   ! Mixed layer level: w-level
+      DO_3D_OVR( nn_hls, nn_hls, nn_hls, nn_hls, nlb10, jpkm1 )   ! Mixed layer level: w-level
          ikt = mbkt(ji,jj)
          hmlp(ji,jj) =   &
@@ -105,30 +103,15 @@
          IF( hmlp(ji,jj) < zN2_c )   nmln(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
       END_3D
-      !
-      ! w-level of the turbocline and mixing layer (iom_use)
-      imld(:,:) = mbkt(:,:) + 1                ! Initialization to the number of w ocean point
-      DO_3DS( 1, 1, 1, 1, jpkm1, nlb10, -1 )   ! from the bottom to nlb10
-         IF( avt (ji,jj,jk) < avt_c * wmask(ji,jj,jk) )   imld(ji,jj) = jk      ! Turbocline 
-      END_3D
-      ! depth of the mixing and mixed layers
-      DO_2D( 1, 1, 1, 1 )
-         iiki = imld(ji,jj)
-         iikn = nmln(ji,jj)
-         hmld (ji,jj) = gdepw(ji,jj,iiki  ,Kmm) * ssmask(ji,jj)    ! Turbocline depth 
-         hmlp (ji,jj) = gdepw(ji,jj,iikn  ,Kmm) * ssmask(ji,jj)    ! Mixed layer depth
-         hmlpt(ji,jj) = gdept(ji,jj,iikn-1,Kmm) * ssmask(ji,jj)    ! depth of the last T-point inside the mixed layer
+      ! depth of the mixed layer
+      DO_2D_OVR( nn_hls, nn_hls, nn_hls, nn_hls )
+         iik = nmln(ji,jj)
+         hmlp (ji,jj) = gdepw(ji,jj,iik  ,Kmm) * ssmask(ji,jj)    ! Mixed layer depth
+         hmlpt(ji,jj) = gdept(ji,jj,iik-1,Kmm) * ssmask(ji,jj)    ! depth of the last T-point inside the mixed layer
       END_2D
       !
-      IF( .NOT.l_offline ) THEN
-         IF( iom_use("mldr10_1") ) THEN
-            IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
-            ELSE                  ;  CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
-            END IF
+      IF( .NOT.l_offline .AND. iom_use("mldr10_1") ) THEN
+         IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
+         ELSE                  ;  CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
          END IF
-         IF( iom_use("mldkz5") ) THEN
-            IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
-            ELSE                  ;  CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
-            END IF
-         ENDIF
       ENDIF
       !
@@ -137,4 +120,44 @@
    END SUBROUTINE zdf_mxl
 
+
+   SUBROUTINE zdf_mxl_turb( kt, Kmm )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE zdf_mxl_turb  ***
+      !!
+      !! ** Purpose :   Compute the turbocline depth.
+      !!
+      !! ** Method  :   The turbocline depth is the depth at which the vertical
+      !!      eddy diffusivity coefficient (resulting from the vertical physics
+      !!      alone, not the isopycnal part, see trazdf.F) fall below a given
+      !!      value defined locally (avt_c here taken equal to 5 cm/s2 by default)
+      !!
+      !! ** Action  :   hmld
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kmm  ! ocean time level index
+      !
+      INTEGER  ::   ji, jj, jk      ! dummy loop indices
+      INTEGER  ::   iik             ! local integer
+      INTEGER, DIMENSION(A2D(nn_hls)) ::   imld   ! 2D workspace
+      !!----------------------------------------------------------------------
+      !
+      ! w-level of the turbocline and mixing layer (iom_use)
+      imld(:,:) = mbkt(A2D(nn_hls)) + 1                ! Initialization to the number of w ocean point
+      DO_3DS( 1, 1, 1, 1, jpkm1, nlb10, -1 )   ! from the bottom to nlb10
+         IF( avt (ji,jj,jk) < avt_c * wmask(ji,jj,jk) )   imld(ji,jj) = jk      ! Turbocline
+      END_3D
+      ! depth of the mixing layer
+      DO_2D_OVR( 1, 1, 1, 1 )
+         iik = imld(ji,jj)
+         hmld (ji,jj) = gdepw(ji,jj,iik  ,Kmm) * ssmask(ji,jj)    ! Turbocline depth
+      END_2D
+      !
+      IF( .NOT.l_offline .AND. iom_use("mldkz5") ) THEN
+         IF( ln_isfcav ) THEN  ;  CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
+         ELSE                  ;  CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
+         END IF
+      ENDIF
+      !
+   END SUBROUTINE zdf_mxl_turb
    !!======================================================================
 END MODULE zdfmxl
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfphy.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfphy.F90	(revision 14852)
@@ -12,4 +12,6 @@
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers variables
+   ! TEMP: [tiling] This change not necessary after finalisation of zdf_osm (not yet tiled)
+   USE domtile
    USE zdf_oce        ! vertical physics: shared variables
    USE zdfdrg         ! vertical physics: top/bottom drag coef.
@@ -54,6 +56,10 @@
    INTEGER, PARAMETER ::   np_OSM = 5   ! OSMOSIS-OBL closure scheme for Kz
 
-   LOGICAL ::   l_zdfsh2   ! shear production term flag (=F for CST, =T otherwise (i.e. TKE, GLS, RIC))
-
+   LOGICAL, PUBLIC ::   l_zdfsh2   ! shear production term flag (=F for CST, =T otherwise (i.e. TKE, GLS, RIC))
+
+   REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avm_k_n !: "Now" avm_k used for calculation of zsh2 with tiling
+
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -180,4 +186,6 @@
       IF( lk_top    .AND. ln_zdfnpc )   CALL ctl_stop( 'zdf_phy_init: npc scheme is not working with key_top' )
       IF( lk_top    .AND. ln_zdfosm )   CALL ctl_warn( 'zdf_phy_init: osmosis gives no non-local fluxes for TOP tracers yet' )
+      ! TEMP: [tiling] This change not necessary after finalisation of zdf_osm (not yet tiled)
+      IF( ln_tile   .AND. ln_zdfosm )   CALL ctl_warn( 'zdf_phy_init: osmosis does not yet work with tiling' )
       IF( lk_top    .AND. ln_zdfmfc )   CALL ctl_stop( 'zdf_phy_init: Mass Flux scheme is not working with key_top' )
       IF(lwp) THEN
@@ -210,7 +218,8 @@
       ENDIF
       !                                ! shear production term flag
-      IF( ln_zdfcst ) THEN   ;   l_zdfsh2 = .FALSE.
-      ELSE                   ;   l_zdfsh2 = .TRUE.
-      ENDIF
+      IF( ln_zdfcst .OR. ln_zdfosm ) THEN   ;   l_zdfsh2 = .FALSE.
+      ELSE                                  ;   l_zdfsh2 = .TRUE.
+      ENDIF
+      IF( ln_tile .AND. l_zdfsh2 ) ALLOCATE( avm_k_n(jpi,jpj,jpk) )
       !                          !== Mass Flux Convectiive algorithm  ==!
       IF( ln_zdfmfc )   CALL zdf_mfc_init       ! Convection computed with eddy diffusivity mass flux
@@ -246,8 +255,21 @@
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indice
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsh2   ! shear production
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) ::   zsh2   ! shear production
+      ! TEMP: [tiling] This change not necessary after finalisation of zdf_osm (not yet tiled)
+      LOGICAL :: lskip
       !! ---------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start('zdf_phy')
+
+      ! TEMP: [tiling] These changes not necessary after finalisation of zdf_osm (not yet tiled)
+      lskip = .FALSE.
+
+      IF( ln_tile .AND. nzdf_phy == np_OSM )  THEN
+         IF( ntile == 1 ) THEN
+            CALL dom_tile_stop( ldhold=.TRUE. )
+         ELSE
+            lskip = .TRUE.
+         ENDIF
+      ENDIF
       !
       IF( l_zdfdrg ) THEN     !==  update top/bottom drag  ==!   (non-linear cases)
@@ -267,38 +289,59 @@
       IF ( ln_drgice_imp) THEN
          IF ( ln_isfcav ) THEN
-            rCdU_top(:,:) = rCdU_top(:,:) + ssmask(:,:) * tmask(:,:,1) * rCdU_ice(:,:)
+            DO_2D_OVR( 1, 1, 1, 1 )
+               rCdU_top(ji,jj) = rCdU_top(ji,jj) + ssmask(ji,jj) * tmask(ji,jj,1) * rCdU_ice(ji,jj)
+            END_2D
          ELSE
-            rCdU_top(:,:) = rCdU_ice(:,:)
+            DO_2D_OVR( 1, 1, 1, 1 )
+               rCdU_top(ji,jj) = rCdU_ice(ji,jj)
+            END_2D
          ENDIF
       ENDIF
 #endif
       !
-      !                       !==  Kz from chosen turbulent closure  ==!   (avm_k, avt_k)
-      !
-      IF( l_zdfsh2 )   &         !* shear production at w-points (energy conserving form)
-         CALL zdf_sh2( Kbb, Kmm, avm_k,   &     ! <<== in
-            &                     zsh2    )     ! ==>> out : shear production
-      !
-      SELECT CASE ( nzdf_phy )                  !* Vertical eddy viscosity and diffusivity coefficients at w-points
-      CASE( np_RIC )   ;   CALL zdf_ric( kt,      Kmm, zsh2, avm_k, avt_k )    ! Richardson number dependent Kz
-      CASE( np_TKE )   ;   CALL zdf_tke( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! TKE closure scheme for Kz
-      CASE( np_GLS )   ;   CALL zdf_gls( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! GLS closure scheme for Kz
-      CASE( np_OSM )   ;   CALL zdf_osm( kt, Kbb, Kmm, Krhs, avm_k, avt_k )    ! OSMOSIS closure scheme for Kz
-!     CASE( np_CST )                                  ! Constant Kz (reset avt, avm to the background value)
-!         ! avt_k and avm_k set one for all at initialisation phase
+      CALL zdf_mxl( kt, Kmm )                        !* mixed layer depth, and level
+
+      ! TEMP: [tiling] These changes not necessary after finalisation of zdf_osm (not yet tiled)
+      IF( .NOT. lskip ) THEN
+         !                       !==  Kz from chosen turbulent closure  ==!   (avm_k, avt_k)
+         !
+         ! NOTE: [tiling] the closure schemes (zdf_tke etc) will update avm_k. With tiling, the calculation of zsh2 on adjacent tiles then uses both updated (next timestep) and non-updated (current timestep) values of avm_k. To preserve results, we save a read-only copy of the "now" avm_k to use in the calculation of zsh2.
+         IF( l_zdfsh2 ) THEN        !* shear production at w-points (energy conserving form)
+            IF( ln_tile ) THEN
+               IF( ntile == 1 ) avm_k_n(:,:,:) = avm_k(:,:,:)     ! Preserve "now" avm_k for calculation of zsh2
+               CALL zdf_sh2( Kbb, Kmm, avm_k_n, &     ! <<== in
+                  &                     zsh2    )     ! ==>> out : shear production
+            ELSE
+               CALL zdf_sh2( Kbb, Kmm, avm_k,   &     ! <<== in
+                  &                     zsh2    )     ! ==>> out : shear production
+            ENDIF
+         ENDIF
+         !
+         SELECT CASE ( nzdf_phy )                  !* Vertical eddy viscosity and diffusivity coefficients at w-points
+         CASE( np_RIC )   ;   CALL zdf_ric( kt,      Kmm, zsh2, avm_k, avt_k )    ! Richardson number dependent Kz
+         CASE( np_TKE )   ;   CALL zdf_tke( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! TKE closure scheme for Kz
+         CASE( np_GLS )   ;   CALL zdf_gls( kt, Kbb, Kmm, zsh2, avm_k, avt_k )    ! GLS closure scheme for Kz
+         CASE( np_OSM )   ;   CALL zdf_osm( kt, Kbb, Kmm, Krhs, avm_k, avt_k )    ! OSMOSIS closure scheme for Kz
+   !     CASE( np_CST )                                  ! Constant Kz (reset avt, avm to the background value)
+   !         ! avt_k and avm_k set one for all at initialisation phase
 !!gm         avt(2:jpim1,2:jpjm1,1:jpkm1) = rn_avt0 * wmask(2:jpim1,2:jpjm1,1:jpkm1)
 !!gm         avm(2:jpim1,2:jpjm1,1:jpkm1) = rn_avm0 * wmask(2:jpim1,2:jpjm1,1:jpkm1)
-      END SELECT
+         END SELECT
+
+         IF( ln_tile .AND. .NOT. l_istiled ) CALL dom_tile_start( ldhold=.TRUE. )
+      ENDIF
       !
       !                          !==  ocean Kz  ==!   (avt, avs, avm)
       !
       !                                         !* start from turbulent closure values
-      avt(:,:,2:jpkm1) = avt_k(:,:,2:jpkm1)
-      avm(:,:,2:jpkm1) = avm_k(:,:,2:jpkm1)
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jpkm1 )
+         avt(ji,jj,jk) = avt_k(ji,jj,jk)
+         avm(ji,jj,jk) = avm_k(ji,jj,jk)
+      END_3D
       !
       IF( ln_rnf_mouth ) THEN                   !* increase diffusivity at rivers mouths
-         DO jk = 2, nkrnf
-            avt(:,:,jk) = avt(:,:,jk) + 2._wp * rn_avt_rnf * rnfmsk(:,:) * wmask(:,:,jk)
-         END DO
+         DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, nkrnf )
+            avt(ji,jj,jk) = avt(ji,jj,jk) + 2._wp * rn_avt_rnf * rnfmsk(ji,jj) * wmask(ji,jj,jk)
+         END_3D
       ENDIF
       !
@@ -309,5 +352,7 @@
                         CALL zdf_ddm( kt, Kmm,  avm, avt, avs )
       ELSE                                            ! same mixing on all tracers
-         avs(2:jpim1,2:jpjm1,1:jpkm1) = avt(2:jpim1,2:jpjm1,1:jpkm1)
+         DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 1, jpkm1 )
+            avs(ji,jj,jk) = avt(ji,jj,jk)
+         END_3D
       ENDIF
       !
@@ -318,28 +363,34 @@
 #if defined key_agrif
       ! interpolation parent grid => child grid for avm_k ( ex : at west border: update column 1 and 2)
-      IF( l_zdfsh2 )   CALL Agrif_avm
+      IF( .NOT. l_istiled .OR. ntile == nijtile ) THEN                       ! Do only on the last tile
+         IF( l_zdfsh2 )   CALL Agrif_avm
+      ENDIF
 #endif
 
       !                                         !* Lateral boundary conditions (sign unchanged)
-      IF( l_zdfsh2 ) THEN
-         CALL lbc_lnk( 'zdfphy', avm_k, 'W', 1.0_wp , avt_k, 'W', 1.0_wp,   &
-            &                    avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
-      ELSE
-         CALL lbc_lnk( 'zdfphy', avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
-      ENDIF
-      !
-      IF( l_zdfdrg ) THEN     ! drag  have been updated (non-linear cases)
-         IF( ln_isfcav ) THEN   ;  CALL lbc_lnk( 'zdfphy', rCdU_top, 'T', 1.0_wp , rCdU_bot, 'T', 1.0_wp )   ! top & bot drag
-         ELSE                   ;  CALL lbc_lnk( 'zdfphy', rCdU_bot, 'T', 1.0_wp )                       ! bottom drag only
-         ENDIF
-      ENDIF
-      !
-      CALL zdf_mxl( kt, Kmm )                        !* mixed layer depth, and level
-      !
-      IF( lrst_oce ) THEN                       !* write TKE, GLS or RIC fields in the restart file
-         IF( ln_zdftke )   CALL tke_rst( kt, 'WRITE' )
-         IF( ln_zdfgls )   CALL gls_rst( kt, 'WRITE' )
-         IF( ln_zdfric )   CALL ric_rst( kt, 'WRITE' )
-         ! NB. OSMOSIS restart (osm_rst) will be called in step.F90 after ww has been updated
+      IF(nn_hls==1) THEN
+         IF( l_zdfsh2 ) THEN
+            CALL lbc_lnk( 'zdfphy', avm_k, 'W', 1.0_wp , avt_k, 'W', 1.0_wp,   &
+                  &                 avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
+         ELSE
+            CALL lbc_lnk( 'zdfphy', avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
+         ENDIF
+         !
+         IF( l_zdfdrg ) THEN     ! drag  have been updated (non-linear cases)
+            IF( ln_isfcav ) THEN   ;  CALL lbc_lnk( 'zdfphy', rCdU_top, 'T', 1.0_wp , rCdU_bot, 'T', 1.0_wp )   ! top & bot drag
+            ELSE                   ;  CALL lbc_lnk( 'zdfphy', rCdU_bot, 'T', 1.0_wp )                           ! bottom drag only
+            ENDIF
+         ENDIF
+      ENDIF
+      !
+      CALL zdf_mxl_turb( kt, Kmm )                   !* turbocline depth
+      !
+      IF( .NOT. l_istiled .OR. ntile == nijtile ) THEN                       ! Do only on the last tile
+         IF( lrst_oce ) THEN                       !* write TKE, GLS or RIC fields in the restart file
+            IF( ln_zdftke )   CALL tke_rst( kt, 'WRITE' )
+            IF( ln_zdfgls )   CALL gls_rst( kt, 'WRITE' )
+            IF( ln_zdfric )   CALL ric_rst( kt, 'WRITE' )
+            ! NB. OSMOSIS restart (osm_rst) will be called in step.F90 after ww has been updated
+         ENDIF
       ENDIF
       !
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfric.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfric.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfric.F90	(revision 14852)
@@ -145,16 +145,16 @@
       !!              PFJ Lermusiaux 2001.
       !!----------------------------------------------------------------------
-      INTEGER                   , INTENT(in   ) ::   kt             ! ocean time-step
-      INTEGER                   , INTENT(in   ) ::   Kmm            ! ocean time level index
-      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   p_sh2          ! shear production term
-      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   p_avm, p_avt   ! momentum and tracer Kz (w-points)
+      INTEGER                             , INTENT(in   ) ::   kt             ! ocean time-step
+      INTEGER                             , INTENT(in   ) ::   Kmm            ! ocean time level index
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk), INTENT(in   ) ::   p_sh2          ! shear production term
+      REAL(wp), DIMENSION(:,:,:)          , INTENT(inout) ::   p_avm, p_avt   ! momentum and tracer Kz (w-points)
       !!
       INTEGER  ::   ji, jj, jk                  ! dummy loop indices
       REAL(wp) ::   zcfRi, zav, zustar, zhek    ! local scalars
-      REAL(wp), DIMENSION(jpi,jpj) ::   zh_ekm  ! 2D workspace
+      REAL(wp), DIMENSION(A2D(nn_hls)) ::   zh_ekm  ! 2D workspace
       !!----------------------------------------------------------------------
       !
       !                       !==  avm and avt = F(Richardson number)  ==!
-      DO_3D( 1, 0, 1, 0, 2, jpkm1 )       ! coefficient = F(richardson number) (avm-weighted Ri)
+      DO_3D_OVR( nn_hls, nn_hls-1, nn_hls, nn_hls-1, 2, jpkm1 )       ! coefficient = F(richardson number) (avm-weighted Ri)
          zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , avm(ji,jj,jk) * rn2(ji,jj,jk) / ( p_sh2(ji,jj,jk) + 1.e-20 ) )  )
          zav   = rn_avmri * zcfRi**nn_ric
@@ -169,10 +169,10 @@
       IF( ln_mldw ) THEN      !==  set a minimum value in the Ekman layer  ==!
          !
-         DO_2D( 0, 0, 0, 0 )             !* Ekman depth
+         DO_2D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 ) 
             zustar = SQRT( taum(ji,jj) * r1_rho0 )
             zhek   = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )   ! Ekman depth
             zh_ekm(ji,jj) = MAX(  rn_mldmin , MIN( zhek , rn_mldmax )  )   ! set allowed range
          END_2D
-         DO_3D( 0, 0, 0, 0, 2, jpkm1 )   !* minimum mixing coeff. within the Ekman layer
+         DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jpkm1 )   !* minimum mixing coeff. within the Ekman layer
             IF( gdept(ji,jj,jk,Kmm) < zh_ekm(ji,jj) ) THEN
                p_avm(ji,jj,jk) = MAX(  p_avm(ji,jj,jk), rn_wvmix  ) * wmask(ji,jj,jk)
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfsh2.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfsh2.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfsh2.F90	(revision 14852)
@@ -55,15 +55,15 @@
       !! References :   Bruchard, OM 2002
       !! ---------------------------------------------------------------------
-      INTEGER                    , INTENT(in   ) ::   Kbb, Kmm             ! ocean time level indices
-      REAL(wp), DIMENSION(:,:,:) , INTENT(in   ) ::   p_avm                ! vertical eddy viscosity (w-points)
-      REAL(wp), DIMENSION(:,:,:) , INTENT(  out) ::   p_sh2                ! shear production of TKE (w-points)
+      INTEGER                              , INTENT(in   ) ::   Kbb, Kmm             ! ocean time level indices
+      REAL(wp), DIMENSION(:,:,:)           , INTENT(in   ) ::   p_avm                ! vertical eddy viscosity (w-points)
+      REAL(wp), DIMENSION(A2D(nn_hls),jpk) , INTENT(  out) ::   p_sh2                ! shear production of TKE (w-points)
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop arguments
-      REAL(wp), DIMENSION(jpi,jpj) ::   zsh2u, zsh2v   ! 2D workspace
+      REAL(wp), DIMENSION(A2D(nn_hls)) ::   zsh2u, zsh2v   ! 2D workspace
       !!--------------------------------------------------------------------
       !
       DO jk = 2, jpkm1                 !* Shear production at uw- and vw-points (energy conserving form)
          IF ( cpl_sdrftx .AND. ln_stshear )  THEN       ! Surface Stokes Drift available  ===>>>  shear + stokes drift contibution
-            DO_2D( 1, 0, 1, 0 )
+            DO_2D( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )
                zsh2u(ji,jj) = ( p_avm(ji+1,jj,jk) + p_avm(ji,jj,jk) )        &
                   &         * ( uu (ji,jj,jk-1,Kmm) -   uu (ji,jj,jk,Kmm)    &
@@ -78,5 +78,5 @@
             END_2D
          ELSE
-            DO_2D( 1, 0, 1, 0 )     !* 2 x shear production at uw- and vw-points (energy conserving form)
+            DO_2D( nn_hls, nn_hls-1, nn_hls, nn_hls-1 )     !* 2 x shear production at uw- and vw-points (energy conserving form)
                zsh2u(ji,jj) = ( p_avm(ji+1,jj,jk) + p_avm(ji,jj,jk) ) &
                   &         * (   uu(ji,jj,jk-1,Kmm) -   uu(ji,jj,jk,Kmm) ) &
@@ -91,5 +91,5 @@
             END_2D
          ENDIF
-         DO_2D( 0, 0, 0, 0 )     !* shear production at w-point ! coast mask: =2 at the coast ; =1 otherwise (NB: wmask useless as zsh2 are masked)
+         DO_2D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )     !* shear production at w-point ! coast mask: =2 at the coast ; =1 otherwise (NB: wmask useless as zsh2 are masked)
             p_sh2(ji,jj,jk) = 0.25 * (   ( zsh2u(ji-1,jj) + zsh2u(ji,jj) ) * ( 2. - umask(ji-1,jj,jk) * umask(ji,jj,jk) )   &
                &                       + ( zsh2v(ji,jj-1) + zsh2v(ji,jj) ) * ( 2. - vmask(ji,jj-1,jk) * vmask(ji,jj,jk) )   )
Index: NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfswm.F90
===================================================================
--- NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfswm.F90	(revision 14851)
+++ NEMO/branches/2021/dev_r13747_HPC-11_mcastril_HPDAonline_DiagGPU/src/OCE/ZDF/zdfswm.F90	(revision 14852)
@@ -63,5 +63,5 @@
       !
       zcoef = 1._wp * 0.353553_wp
-      DO_3D( 0, 0, 0, 0, 2, jpkm1 )
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 2, jpkm1 )
          zqb = zcoef * hsw(ji,jj) * tsd2d(ji,jj) * EXP( -3. * wnum(ji,jj) * gdepw(ji,jj,jk,Kmm) ) * wmask(ji,jj,jk)
          !
